#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_rwlock_timedwrlock - lock a read-write lock for writing

## Synopsis

#include <pthread.h>
#include <time.h>

int pthread_rwlock_timedwrlock(pthread_rwlock_t *restrict rwlock, const struct timespec *restrict abs_timeout);

## Description

The pthread_rwlock_timedwrlock function shall apply a write lock to the read-write lock referenced by rwlock as in the pthread_rwlock_wrlock(3) function. However, if the lock cannot be acquired without waiting for other threads to unlock the lock, this wait shall be terminated when the specified timeout expires. The timeout shall expire when the absolute time specified by abs_timeout passes, as measured by the clock on which timeouts are based (that is, when the value of that clock equals or exceeds abs_timeout), or if the absolute time specified by abs_timeout has already been passed at the time of the call.

The timespec data type is defined in the <time.h> header. Under no circumstances shall the function fail with a timeout if the lock can be acquired immediately. The validity of the abs_timeout parameter need not be checked if the lock can be immediately acquired.

The calling thread may deadlock if at the time the call is made it holds the read-write lock. The results are undefined if this function is called with an uninitialized read-write lock.

Pthreads-w32 defines _POSIX_READER_WRITER_LOCKS in pthread.h as 200112L to indicate that the reader/writer routines are implemented and may be used.

## Return Value

The pthread_rwlock_timedwrlock function shall return zero if the lock for writing on the read-write lock object referenced by rwlock is acquired. Otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_rwlock_timedwrlock function shall fail if:

ETIMEDOUT
  The lock could not be acquired before the specified timeout expired.

The pthread_rwlock_timedwrlock function may fail if:

EINVAL
  The value specified by rwlock does not refer to an initialized read-write lock object, or the abs_timeout nanosecond value is less than zero or greater than or equal to 1000 million.

This function shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

Applications using this function may be subject to priority inversion, as discussed in the Base Definitions volume of IEEE Std 1003.1-2001, Section 3.285, Priority Inversion.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_rwlock_destroy(3) , pthread_rwlock_rdlock(3) , pthread_rwlock_timedrdlock(3) , pthread_rwlock_tryrdlock(3) , pthread_rwlock_trywrlock(3) , pthread_rwlock_unlock(3) , pthread_rwlock_wrlock(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>, <time.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright